//
//  MYFactoryManager.h
//  GoHiking_app
//
//  Created by dwl on 17/10/13.
//  Copyright (c) 2017年 dwl. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

//tool
//#import "MYFactoryManager.h"
#import "UIView+ST.h"
#import "AlgorithmTool.h"
#import "UIColor+Hex.h"

//蓝牙
#import <CoreBluetooth/CoreBluetooth.h>
#import "BTDataProcess.h"
//蓝牙提供的sdk算法
#define LEFT_FOOT_OC 1
#define RIGHT_FOOT_OC 2
//蓝牙框架封装
#import "LEONBLManager.h"
#import "BTDataSend.h"
#import "BTDataAnalysis.h"
#import "CBPeripheral+ADName.h"
#define BTDataInstance [BTDataProcess sharedInstance]
#define LEManager [LEONBLManager sharedInstance]

//http
#import "HTTPDataProcession.h"
#import "UserFriendsModel.h"
//第三方
#import "AFNetworking.h"
#import "MBProgressHUD.h"

//UI
#import "SearchDeviceViewController.h"
#import "FriendsListViewController.h"
#import "MainLoadingView.h"
#import "ViceLoadingView.h"
#import "PopupView.h"
#import "NoDeviceTip.h"
#import <AudioToolbox/AudioToolbox.h>
#import "DebugView.h"
#import "CacheTool.h"

/*************************** 获取屏幕 宽度、高度 ***************************/
#define SCREEN_WIDTH ([UIScreen mainScreen].bounds.size.width)
#define SCREEN_HEIGHT ([UIScreen mainScreen].bounds.size.height)
/*************************** 状态栏+导航栏 高度 ***************************/
#define getRectNavAndStatusHight  self.navigationController.navigationBar.frame.size.height+[[UIApplication sharedApplication] statusBarFrame].size.height
#define getTarbarHight (SCREEN_HEIGHT>=812?83:49)
/*************************** 比例系数布局  ***************************/
#define SCALEoefficient(num)   (SCREEN_WIDTH/667.0)*(num)
#define SCALE_HIGHT_oefficient(num)   (SCREEN_HEIGHT/375.0)*(num)
/*************************** 字号大小  ***************************/
#define SCALEoefficient_20 20.0*(SCREEN_WIDTH/320.0)///<大标题
#define SCALEoefficient_18 18.0*(SCREEN_WIDTH/320.0)///<附标题
#define SCALEoefficient_16 16.0*(SCREEN_WIDTH/320.0)///<中标题
#define SCALEoefficient_14 14.0*(SCREEN_WIDTH/320.0)///<小标题

//app跳转 用户信息
#define IOSSDK_USERINFO @"iosSdk_userInfo"
//缓存的步频数据
#define IOSSDK_MOTIONCOUNT @"iosSdk_motionCount"
 
//custom System UserDefaults
#define IOS_NSUSERDEFAULT [NSUserDefaults standardUserDefaults]
#define CUS_NOTIFICATIONCENTER [NSNotificationCenter defaultCenter]

//log
//#ifdef DEBUG
//#define NSLog(...) NSLog(@"%s 第%d行 \n %@\n\n",__func__,__LINE__,[NSString stringWithFormat:__VA_ARGS__])
//#else
//#define NSLog(...)
//#endif

@interface MYFactoryManager : NSObject

@property (nonatomic,assign) UIBackgroundTaskIdentifier bgTask;

#pragma mark -- UI
//单例
+(instancetype)sharedInstance;
//边框
+ (void)makeBoundsWithView:(UIView *)view color:(UIColor *)color width:(CGFloat)width;
//圆角
+ (void)clipsToBoundsWithView:(UIView *)view Radius:(NSInteger)radius;

//正常加载还是打包后sdk加载
+(UIImage*)imageString:(NSString*)imageName;


@end
